# BASH SETTINGS --------------------------------------------------------------
# If not running interactively, don't do anything
[[ $- != *i* ]] && return

PATH="${XDG_BIN_HOME}:${PATH}"

#History
HISTCONTROL=ignoreboth
HISTSIZE=1000
HISTFILESIZE=2000
history -a

# append to the history file, don't overwrite it
shopt -s histappend

# check the window size after each command and, if necessary,
# update the values of LINES and COLUMNS.
shopt -s checkwinsize


#<C> + arrow navigation
bind '"\e[1;5D" backward-word'
bind '"\e[1;5C" forward-word'


# make less more friendly for non-text input files, see lesspipe(1)
[ -x /usr/bin/lesspipe ] && eval "$(SHELL=/bin/sh lesspipe)"

# set variable identifying the chroot you work in (used in the prompt below)
if [ -z "${debian_chroot:-}" ] && [ -r /etc/debian_chroot ]; then
    debian_chroot=$(cat /etc/debian_chroot)
fi

# set a fancy prompt (non-color, unless we know we "want" color)
case "$TERM" in
    xterm-color|*-256color) color_prompt=yes;;
esac

# uncomment for a colored prompt, if the terminal has the capability; turned
# off by default to not distract the user: the focus in a terminal window
# should be on the output of commands, not on the prompt
#force_color_prompt=yes

if [ -n "$force_color_prompt" ]; then
    if [ -x /usr/bin/tput ] && tput setaf 1 >&/dev/null; then
	# We have color support; assume it's compliant with Ecma-48
	# (ISO/IEC-6429). (Lack of such support is extremely rare, and such
	# a case would tend to support setf rather than setaf.)
	color_prompt=yes
    else
	color_prompt=
    fi
fi

if [ "$color_prompt" = yes ]; then
    PS1='${debian_chroot:+($debian_chroot)}\[\033[01;32m\]\u@\h\[\033[00m\]:\[\033[01;34m\]\w\[\033[00m\]\$ '
else
    PS1='${debian_chroot:+($debian_chroot)}\u@\h:\w\$ '
fi
unset color_prompt force_color_prompt

# If this is an xterm set the title to user@host:dir
case "$TERM" in
xterm*|rxvt*)
    PS1="\[\e]0;${debian_chroot:+($debian_chroot)}\u@\h: \w\a\]$PS1"
    ;;
*)
    ;;
esac

# enable color support of ls and also add handy aliases
if [ -x /usr/bin/dircolors ]; then
    test -r ~/.dircolors && eval "$(dircolors -b ~/.dircolors)" || eval "$(dircolors -b)"
    alias ls='ls --color=auto'
    #alias dir='dir --color=auto'
    #alias vdir='vdir --color=auto'

    alias grep='grep --color=auto'
    alias fgrep='fgrep --color=auto'
    alias egrep='egrep --color=auto'
fi

# colored GCC warnings and errors
#export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'

# some more ls aliases
alias ll='ls -alF'
alias la='ls -A'
alias l='ls -CF'

# Add an "alert" alias for long running commands.  Use like so:
#   sleep 10; alert
alias alert='notify-send --urgency=low -i "$([ $? = 0 ] && echo terminal || echo error)" "$(history|tail -n1|sed -e '\''s/^\s*[0-9]\+\s*//;s/[;&|]\s*alert$//'\'')"'

# Alias definitions.
# You may want to put all your additions into a separate file like
# ~/.bash_aliases, instead of adding them here directly.
# See /usr/share/doc/bash-doc/examples in the bash-doc package.

if [ -f ~/.bash_aliases ]; then
    . ~/.bash_aliases
fi

# enable programmable completion features (you don't need to enable
# this, if it's already enabled in /etc/bash.bashrc and /etc/profile
# sources /etc/bash.bashrc).
if ! shopt -oq posix; then
  if [ -f /usr/share/bash-completion/bash_completion ]; then
    . /usr/share/bash-completion/bash_completion
  elif [ -f /etc/bash_completion ]; then
    . /etc/bash_completion
  elif [ -f "$(brew --prefix)/etc/profile.d/bash_completion.sh" ]; then
    . /usr/local/etc/profile.d/bash_completion.sh
  fi
fi

command_exists() { command -v "$@" >/dev/null 2>&1; }

# ruby (via brew)

if [ -d "$(brew --prefix)/opt/ruby/bin" ]; then
    PATH="$(brew --prefix)/opt/ruby/bin:${PATH}"
fi

# z
[ -f "${XDG_CONFIG_HOME}/z/z.sh" ] && . "${XDG_CONFIG_HOME}/z/z.sh"

# fzf
[ -f "${XDG_CONFIG_HOME}/fzf/fzf.bash" ] && . "${XDG_CONFIG_HOME}/fzf/fzf.bash"

# sdkman
[ -f "${SDKMAN_DIR}/bin/sdkman-init.sh" ] && . "${SDKMAN_DIR}/bin/sdkman-init.sh"

# pyenv
if command_exists pyenv; then
    eval "$(pyenv init --path)"
fi

# jenv
if command_exists jenv; then
    eval "$(jenv init -)" >/dev/null 2>&1;
fi

# AWS CLI - command completion
if command_exists aws && command_exists aws_completer ; then
    complete -C "$(which aws_completer)" aws
fi

# Rancher
if [ -d "${HOME}/.rd/bin" ]; then
    PATH="${HOME}/.rd/bin:${PATH}"
fi

# Google CLoud SDK - command completion
[ -f "${GCLOUD_SDK_DIR}/completion.bash.inc" ] && . "${GCLOUD_SDK_DIR}/completion.bash.inc"

# Oh My Bash
if [ -f "${OSH}/oh-my-bash.sh" ]; then
    . "${XDG_CONFIG_HOME}/oh-my-bash/config.sh"
    . "${OSH}/oh-my-bash.sh"
fi

# Generate git config
gen-git-config

# Generate Alacritty config
gen-alacritty-config
